#!/bin/sh


#获取测试机CPU核列表
get_cpu_list()
{

	export total_cpus=0
	cpu_list=$(numactl --show | grep physcpubind | cut -d ':' -f 2)
	for cpu in $cpu_list; do
		total_cpus=$((total_cpus+1))
	done

	echo "The system contains $total_cpus physic cpus: $cpu_list"

	if [ $total_cpus -le 1 ]; then
		echo "SUT does not a Multi-core machine"
	fi

}

# 将进程切换到特定cpu上调度
thread_switch_cpu()
{
	export pid=-1

    #创建一个进程,首先绑定到cpu0上
	./bin/create_thread -n 0 &
	if [ $? -ne 0 ]; then
		echo "Fail: can not create thread for cpu 0"
		return  
	else
		pid=$!
	fi

	echo "Pass:create one thread for cpu 0"

	#在CPU1、2、3上切换调度进程
	if [ $total_cpus -lt 4 ];then
		# for ((i=1;i<=$total_cpus;i++))
		for i in `seq 1 $total_cpus`
		do
			./bin/thread_set_affinity -p $pid -c $i &
			if [ $? -ne 0 ]; then
				# echo "Fail: can not switch thread $pid to cpu $i"
				:
			else
				# echo "Pass: switch thread $pid to cpu $i success"
				sleep 3
			fi
		done
	else
		for i in `seq 1 3`
		do
			./bin/thread_set_affinity -p $pid -c $i &
			if [ $? -ne 0 ]; then
				# echo "Fail: can not switch thread $pid to cpu $i"
				:
			else
				# echo "Pass: switch thread $pid to cpu $i success"
				sleep 3
			fi
		done
	fi


}


exit_test()
{
	kill  $pid >/dev/null
	echo "Pass: thread $pid exit success"
}

test_run()
{
	make clean
	make
	get_cpu_list
	thread_switch_cpu
	exit_test
}

test_run



