#define _GNU_SOURCE
#include <sched.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <syscall.h>

// static unsigned long get_processorid(void)
// {
//     unsigned long ultaskcpu=0;
//     unsigned long uloopi = 0;
//     char szfilename[50];
//     char cflag=0;    
//     char szbuf[512];
//     FILE *pstfp=NULL;

//     memset(szfilename,0,50);
//     snprintf(szfilename,sizeof(szfilename),"/proc/%d/task/%d/stat",getpid(),gettid());
//     pstfp=fopen(szfilename,"r");
//     if(NULL==pstfp)
//     {
//         return 30;
//     }
//     while(0 ==feof(pstfp))
//     {
//         if(uloopi == 38)
//         {
//             fgets(szbuf,sizeof(szbuf),pstfp);
//             sscanf(szbuf,"%lu",&ultaskcpu);
//             break;
//         }    
//         cflag=fgetc(pstfp);
//         if(' ' == cflag)
//         {
//             uloopi++;
//         }

//     }

//     fclose(pstfp);
//     return ultaskcpu;
    
// }

int main(int argc, char **argv)
{
    cpu_set_t cpuset;
    char *program_name = *argv;
    int i = 0;
    int cpu_num=-1;


    while ((i = getopt(argc, argv, "n:?")) != EOF)
    {
        switch (i)
        {
        case 'n': /* 要绑定的cpu号*/
            cpu_num = atoi(optarg);
            break;
        case '?': // 命令行参数不正确，退出程序
            fprintf(stderr, "\nerr:cmd %s param is incorrect!\n", program_name);
            exit(2);
            break;
        }
    }

    if(argc<=1||cpu_num==-1)
    {
        // 命令行参数不正确，退出程序
        fprintf(stderr, "\nerr:cmd %s param is incorrect!\n", program_name);
        exit(2);
    }

    CPU_ZERO(&cpuset);   // 初始化CPU集合，将 cpuset 置为空
    CPU_SET(cpu_num, &cpuset); // 将本进程绑定到 CPU2 上

    // 设置进程的 CPU 亲和性
    if (sched_setaffinity(0, sizeof(cpuset), &cpuset) == -1)
    {
        printf("Fail:Set thread %d on CPU %d affinity failed, error: %s\n", getpid(),cpu_num,strerror(errno));
        return -1;
    }

    while (1)
    {
        // printf("\nthis thread %d is running on cpu %lu\n",getpid(),get_processorid());
        sleep(1);
    }

    return 0;
}